# .
# encoders.rb
#   
# Copyright 2010 by siberas, http://www.siberas.de
# 
# This file is part of WATOBO (Web Application Tool Box)
#        http://watobo.sourceforge.com
# 
# WATOBO is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation version 2 of the License.
# 
# WATOBO is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with WATOBO; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# .
require 'base64'
require 'cgi'

module Watobo
  module Transcoders
    
    def url_encode
       CGI::escape(self)  
    end
    
    def url_decode
      CGI::unescape(self)
    end
    
    
    def b64decode
      begin
        b64string = self
        rs = Base64.decode64(b64string)
        return rs
      rescue
        return ""
      end
    end
    
    
    def b64encode
      begin
        plain = self
        rs = Base64.encode64(plain)
        # we only need a simple string without linebreaks
        rs.gsub!(/\n/,'')
        rs.strip!
        return rs
      rescue
        return ""
      end
    end
    
    def hex2int
      begin
        plain = self.strip
        if plain =~ /^[0-9a-fA-F]{1,8}$/ then
          return plain.hex
        else
          return ""
        end
      rescue
        return ""
      end
    end
    
    def hexencode
      begin
        plain = self
        
        rs = ""
        plain.each_byte { |b|
          rs += "%02X" % b
          
        }
        return rs
      rescue
        return ""
      end
      
    end
    def hexdecode
      hexstring = self
      x=0
      rs=""
      begin
        while x < hexstring.length do
          val = hexstring[x..x+1].hex
          rs += val.chr if val > 0 
          x += 2
        end
        return rs
      rescue
        return ""
      end
    end
  end
end
