# .
# quick_scan_dialog.rb
#   
# Copyright 2010 by siberas, http://www.siberas.de
# 
# This file is part of WATOBO (Web Application Tool Box)
#        http://watobo.sourceforge.com
# 
# WATOBO is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation version 2 of the License.
# 
# WATOBO is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with WATOBO; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# .
require 'lib/gui/check_policy_menu'
module Watobo
  module Gui
    class QuickScanDialog < FXDialogBox
      
      include Responder
      attr :active_policy
      attr :selectedModules
      
      def onAccept(sender, sel, event)
        @selectedPolicy = @policyFrame.policy_name
        #@checks.each do |c|
        #  c.enabled = @policyFrame.isElementChecked(c) ? true : false
          
          # puts c.info[:check_name]
          # puts enabled
        #end
         @selectedModules = @policyFrame.getSelectedModules()
        getApp().stopModal(self, 1)
        self.hide()
        return 1
      end
      
      def initialize(parent, project)
        super(parent, "Quick Scan", DECOR_ALL, :width => 300, :height => 400)
       # @active_policy = 'Default'
        @selectedModules = []
        FXMAPFUNC(SEL_COMMAND, ID_ACCEPT, :onAccept)
        
        base_frame = FXVerticalFrame.new(self, :opts => LAYOUT_FILL_X|LAYOUT_FILL_Y)
        @policyFrame = ChecksPolicyFrame.new(base_frame, project.active_checks, project.settings[:policy])
        
        
        # BUTTONS
        buttons_frame = FXHorizontalFrame.new(base_frame, :opts => LAYOUT_FILL_X)
        @acceptButton = FXButton.new(buttons_frame, "Accept" ,
        :target => self, :selector => FXDialogBox::ID_ACCEPT,
        :opts => BUTTON_NORMAL|LAYOUT_RIGHT)  
        
        @cancelButton = FXButton.new(buttons_frame, "Cancel" ,
        :target => self, :selector => FXDialogBox::ID_CANCEL,
        :opts => BUTTON_NORMAL|LAYOUT_RIGHT)  
        
        
        #@filterCombo.appendItem("ohne Filter", nil)
        
        
        
      end
    end
  end
end
