# .
# select_sites_frame.rb
#   
# Copyright 2010 by siberas, http://www.siberas.de
# 
# This file is part of WATOBO (Web Application Tool Box)
#        http://watobo.sourceforge.com
# 
# WATOBO is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation version 2 of the License.
# 
# WATOBO is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with WATOBO; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# .
module Watobo
  module Gui
    class SelectSitesFrame_UNUSED < FXVerticalFrame
      attr :sites
      
      def onDeselectAll(sender, sel, item)
        
        @sites.each do |site, sel|
          sel.value = false
        end
        
        @checkBoxList.each do |cb|
          cb.handle(self, FXSEL(SEL_UPDATE, 0), nil)
        end
      end
      
      def onSelectAll(sender, sel, item)
        # @checkBoxList.each do |cb|
        #  cb.setCheck(true)
        #end
        @sites.each do |site, sel|
          sel.value = true
        end
        
        @checkBoxList.each do |cb|
          cb.handle(self, FXSEL(SEL_UPDATE, 0), nil)
        end
      end
      
      def selectedSites()
        sites = []
        @sites.each do |site, sel|
          sites.push site if sel.value
        end
        return sites
      end
      
      def initialize(parent, project, opts)
        @parent = parent
        
        @project = project
        @interface = @project.interface
        
        @checkBoxList = []
        # Invoke base class initialize function first        
        super(parent, :opts => opts, :padding => 0)
        titleFrame = FXHorizontalFrame.new(self, LAYOUT_FILL_X|FRAME_GROOVE)
        quickSelectFrame = FXHorizontalFrame.new(self, LAYOUT_FILL_X)
        FXButton.new(quickSelectFrame, "Deselect All", nil, nil, 0, FRAME_RAISED|FRAME_THICK).connect(SEL_COMMAND, method(:onDeselectAll))
        FXButton.new(quickSelectFrame, "Select All", nil, nil, 0, FRAME_RAISED|FRAME_THICK).connect(SEL_COMMAND, method(:onSelectAll))
        FXLabel.new(titleFrame, "Select Scan Targets")
        sitesArea = FXScrollWindow.new(self, SCROLLERS_NORMAL|LAYOUT_FILL_X|LAYOUT_FILL_Y)
        sitesFrame = FXVerticalFrame.new(sitesArea, :opts => LAYOUT_FILL_X|LAYOUT_FILL_Y, :padding => 0)
        # create site list
        @sites = Hash.new
        @project.chat_list.each do |chat|
          site = chat.request.site
          if not @sites.include?(site)
            cache = FXDataTarget.new
            b = FXCheckButton.new(sitesFrame, site, cache, FXDataTarget::ID_VALUE, ICON_BEFORE_TEXT|LAYOUT_SIDE_LEFT)
            @checkBoxList.push b
            cache.value = true
            b.setCheck(true)
            
            cache.connect(SEL_COMMAND) do |sender, sel, item|
              
              puts cache.value
            end
            #  b.connect(SEL_COMMAND) do |sender, sel, item|
            #    toggle = cache.value ? false : true
            #    b.setCheck(toggle)
            #    @sites[sender.to_s].value = toggle
            #    puts toggle
            #  end
            
            @sites[site] = cache 
            @interface.default_settings[:domain_filters].each do |filter|              
              if site =~ /^#{filter}$/ then
                @sites[site].value = false
                b.setCheck(false)
              end
            end
            
          end
        end
        
        
        
        
        
      end
      
      
    end #EOC
    #--
  end
end