# .
# tagless_viewer.rb
#   
# Copyright 2010 by siberas, http://www.siberas.de
# 
# This file is part of WATOBO (Web Application Tool Box)
#        http://watobo.sourceforge.com
# 
# WATOBO is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation version 2 of the License.
# 
# WATOBO is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with WATOBO; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# .
require 'lib/requesteditor'
module Watobo
  module Gui
    class TaglessViewer < SimpleTextView
      def normalizeText(text)
        dummy = [] 
        if text.class.to_s =~ /String/i then 
          dummy = text.split("\n")
        elsif text.class.to_s =~ /Array/i then
          begin
            text.body.each do |b|
              dummy.concat b.split("\n")
            end
          rescue => bang
            dummy = text
          end
          
        else
          return nil
        end
        
        printable = []
        dummy.each do |l|
          l.strip!
          l.gsub!(/[^[:print:]]/,'.')
          l.gsub!(/<[^<]*>/,'')
          printable.push l if l.length > 0
        end
        dummy = printable.join("\n")
        return dummy
      end
      
      def initialize(owner, opts)
        super(owner, opts)
      end
    end
    
    
    
  end
end