# .
# qClipboard.rb
#   
# Copyright 2010 by siberas, http://www.siberas.de
# 
# This file is part of WATOBO (Web Application Tool Box)
#        http://watobo.sourceforge.com
# 
# WATOBO is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation version 2 of the License.
# 
# WATOBO is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with WATOBO; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# .
require 'singleton'
require 'thread'
require 'Win32API'

module Watobo
  module Framework
    
    class Clipboard_OLD
      include Singleton
      
      CF_TEXT = 1
      
      def initialize
        @@mutex = Mutex.new
        
        @@open = Win32API.new("user32","OpenClipboard",['L'],'L')
        @@close = Win32API.new("user32","CloseClipboard",[],'L')
        @@empty = Win32API.new("user32","EmptyClipboard",[],'L')
        @@set = Win32API.new("user32","SetClipboardData",['L','P'],'L')
        @@get = Win32API.new("user32", "GetClipboardData", ['L'], 'L')
        @@lock = Win32API.new("kernel32", "GlobalLock", ['L'], 'P')
        @@unlock = Win32API.new("kernel32", "GlobalUnlock", ['L'], 'L')
      end
      
      def copy
        @@mutex.synchronize do
          @@open.Call(0)
          str = @@lock.Call(@@get.Call(CF_TEXT))
          @@unlock.Call(@@get.Call(CF_TEXT))
          @@close.Call
          
          return str
        end
      end
      
      def paste(str)
        @@mutex.synchronize do
          @@open.Call(0)
          @@empty.Call
          @@set.Call(CF_TEXT, str)
          @@close.Call
          @@lock = Win32API.new("kernel32", "GlobalLock", ['L'], 'P')
          @@unlock = Win32API.new("kernel32", "GlobalUnlock", ['L'], 'L')
          
          return nil
        end
      end
      
      private
    end
  end
end