# .
# response_hash.rb
#   
# Copyright 2010 by siberas, http://www.siberas.de
# 
# This file is part of WATOBO (Web Application Tool Box)
#        http://watobo.sourceforge.com
# 
# WATOBO is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation version 2 of the License.
# 
# WATOBO is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with WATOBO; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# .
require 'digest/md5'

module Watobo
  module Utils
    def Utils.responseHash(request, response)
      begin
        if request.body and response.body then
          #     request.extend Watobo::Parser::Web10
          #     request.extend Watobo::Framework::Shaper::Web10
          
          #     response.extend Watobo::Parser::Web10
          #     response.extend Watobo::Framework::Shaper::Web10
          
          body = response.body
          
          
          # remove all parm/value pairs
          request.get_parm_names.each do |p|
            body.gsub!(/#{Regexp.quote(p)}/, '') 
            val = request.get_parm_value(p)
            body.gsub!(/#{Regexp.quote(val)}/, '') 
          end
          request.post_parm_names.each do |p|
            body.gsub!(/#{Regexp.quote(p)}/, '') 
            val = request.post_parm_value(p)
            body.gsub!(/#{Regexp.quote(val)}/, '')  
          end
          # remove date format 01.02.2009
          body.gsub!(/\d{1,2}\.\d{1,2}.\d{2,4}/, "")
          # remove date format 02/2009
          body.gsub!(/\d{1,2}(.\|\/)d{2,4}/, "")
          #remove time
          body.gsub!(/\d{1,2}:\d{1,2}(:\d{1,2})?/, '')
          
          return body, Digest::MD5.hexdigest(body)
          
        elsif response.body then
          return body, Digest::MD5.hexdigest(response.body)
        else
          return nil
        end
      rescue => bang
        puts bang
        puts bang.backtrace
      end
      return nil
      
    end
    
    # smart hashes are necessary for blind sql injections tests
    def Utils.smartHash(orig_request, request, response)
      begin
        if request.body and response.body then
          
          
#          request.extend Watobo::Parser::Web10
#          request.extend Watobo::Framework::Shaper::Web10
          
#          response.extend Watobo::Parser::Web10
#          response.extend Watobo::Framework::Shaper::Web10
          
          
          dummy = response.body.split("\n")
          dummy = dummy.map! { |line|
            # remove all non-printables
            line.gsub!(/[^[:print:]]/,'')
            # shrink line
            line.strip!
            # remove possible chunk values
            line = nil if line =~ /^[0..9a..f]+$/i
            # remove date format 01.02.2009
            line.gsub!(/\d{1,2}\.\d{1,2}.\d{2,4}/, "")
            # remove date format 02/2009
            line.gsub!(/\d{1,2}(.\|\/)d{2,4}/, "")
            #remove time
            line.gsub!(/\d{1,2}:\d{1,2}(:\d{1,2})?/, '')
            
            # clean up
            line = line.empty? ? nil : line
            line
          }
          dummy.compact!
          
          body = dummy.join
          
          request.get_parm_names.each do |p|
            body.gsub!(/#{Regexp.quote(p)}/, '') 
            body.gsub!(/#{Regexp.quote(CGI::unescape(p))}/, '')
            
            val = request.get_parm_value(p)
            body.gsub!(/#{Regexp.quote(val)}/, '') 
            body.gsub!(/#{Regexp.quote(CGI::unescape(val))}/, '')
            
          end
          
          request.post_parm_names.each do |p|
            body.gsub!(/#{Regexp.quote(p)}/, '')
            body.gsub!(/#{Regexp.quote(CGI::unescape(p))}/, '')
            
            val = request.post_parm_value(p)
            body.gsub!(/#{Regexp.quote(val)}/, '')
            body.gsub!(/#{Regexp.quote(CGI::unescape(val))}/, '')
          end
          
          # remove all parm/value pairs
          orig_request.get_parm_names.each do |p|
            body.gsub!(/#{Regexp.quote(p)}/, '') 
            body.gsub!(/#{Regexp.quote(CGI::unescape(p))}/, '')
            
            val = orig_request.get_parm_value(p)
            body.gsub!(/#{Regexp.quote(val)}/, '') 
            body.gsub!(/#{Regexp.quote(CGI::unescape(val))}/, '')
          end
          
          orig_request.post_parm_names.each do |p|
            body.gsub!(/#{Regexp.quote(p)}/, '')
            body.gsub!(/#{Regexp.quote(CGI::unescape(p))}/, '')
            
            val = orig_request.post_parm_value(p)
            body.gsub!(/#{Regexp.quote(val)}/, '')
            body.gsub!(/#{Regexp.quote(CGI::unescape(val))}/, '')
          end
          return body, Digest::MD5.hexdigest(body)
        else
          return nil
        end
      rescue => bang
        return body, Digest::MD5.hexdigest(body||="")
      end
   
      
   end
    
  end
end
